# ArcGISTiledElevationTerrainProvider

#### new Cesium.ArcGISTiledElevationTerrainProvider(options)
Core/ArcGISTiledElevationTerrainProvider.js 48

A `TerrainProvider` that produces terrain geometry by tessellating height maps retrieved from Elevation Tiles of an an ArcGIS ImageService.

Name | Type | Description
--- | --- | ---

`options`

Object

Object with the following properties:

Name | Type | Description
--- | --- | ---
`url` | Resource | String | Promise.<Resource> | Promise.<String> | The URL of the ArcGIS ImageServer service.
`token` | String | optional The authorization token to use to connect to the service.
`ellipsoid` | Ellipsoid | optional The ellipsoid. If the tilingScheme is specified, this parameter is ignored and the tiling scheme's ellipsoid is used instead. If neither parameter is specified, the WGS84 ellipsoid is used.

##### Example:

    var terrainProvider = new Cesium.ArcGISTiledElevationTerrainProvider({
      url : 'https://elevation3d.arcgis.com/arcgis/rest/services/WorldElevation3D/Terrain3D/ImageServer',
      token : 'KED1aF_I4UzXOHy3BnhwyBHU4l5oY6rO6walkmHoYqGp4XyIWUd5YZUC1ZrLAzvV40pR6gBXQayh0eFA8m6vPg..'
    });
    viewer.terrainProvider = terrainProvider;

##### See:

- TerrainProvider

### Members

#### readonly availability : TileAvailability
Core/ArcGISTiledElevationTerrainProvider.js 312

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This function should not be called before `TerrainProvider#ready` returns true. This property may be undefined if availability information is not available.

#### readonly credit : Credit
Core/ArcGISTiledElevationTerrainProvider.js 219

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain. This function should not be called before `ArcGISTiledElevationTerrainProvider#ready` returns true.

#### readonly errorEvent : Event
Core/ArcGISTiledElevationTerrainProvider.js 206

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : Boolean
Core/ArcGISTiledElevationTerrainProvider.js 298

Gets a value indicating whether or not the requested tiles include vertex normals. This function should not be called before `ArcGISTiledElevationTerrainProvider#ready` returns true.

#### readonly hasWaterMask : Boolean
Core/ArcGISTiledElevationTerrainProvider.js 285

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. This function should not be called before `ArcGISTiledElevationTerrainProvider#ready` returns true.

#### readonly ready : Boolean
Core/ArcGISTiledElevationTerrainProvider.js 258

Gets a value indicating whether or not the provider is ready for use.

#### readonly readyPromise : Promise.<Boolean>
Core/ArcGISTiledElevationTerrainProvider.js 270

Gets a promise that resolves to true when the provider is ready for use.

#### readonly tilingScheme : GeographicTilingScheme
Core/ArcGISTiledElevationTerrainProvider.js 239

Gets the tiling scheme used by this provider. This function should not be called before `ArcGISTiledElevationTerrainProvider#ready` returns true.

### Methods

#### getLevelMaximumGeometricError(level) → Number
Core/ArcGISTiledElevationTerrainProvider.js 442

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | Number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean|undefined
Core/ArcGISTiledElevationTerrainProvider.js 464

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
Core/ArcGISTiledElevationTerrainProvider.js 491

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
Core/ArcGISTiledElevationTerrainProvider.js 339

Requests the geometry for a given tile. This function should not be called before `ArcGISTiledElevationTerrainProvider#ready` returns true. The result includes terrain data and indicates that all child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.